apiVersion: apps/v1
kind: Deployment
metadata:
  name: myapp-deployment
  namespace: app-web
  labels:
    app: my-app # label of deployment
spec:
  replicas: 10
  selector:
    matchLabels:
      app: my-app
  template:
    metadata:
      labels:
        app: my-app # map (label of deployment)
    spec:
      containers:
        - name: node-app
          image: nginx
          imagePullPolicy: IfNotPresent
          resources:
            # Specifying the resourses that we might need for our application
            limits:
              memory: "128Mi"
              cpu: "500m"
          ports:
            - containerPort: 80
          env:
            - name: MY_NODE_NAME
              valueFrom:
                fieldRef:
                  fieldPath: spec.nodeName
            - name: MY_POD_NAME
              valueFrom:
                fieldRef:
                  fieldPath: metadata.name
            - name: MY_POD_NAMESPACE
              valueFrom:
                fieldRef:
                  fieldPath: metadata.namespace
            - name: MY_POD_IP
              valueFrom:
                fieldRef:
                  fieldPath: status.podIP
            - name: MY_POD_SERVICE_ACCOUNT
              valueFrom:
                fieldRef:
                  fieldPath: spec.serviceAccountName


# Use command:
# Scale => kubectl -n {namespace_name} scale deployment {deployment_name} --replicas={number_pod}
# Upgrade deployment => kubectl -n {namespace_name} set image deployment {deployment_name} node-app={image_name_version} 

# Check history => kubectl -n {namespace_name} rollout history deployments {deployment_name}

# Rollback (old version) => kubectl -n {namespace_name} rollout undo deployments {deployment_name} --to-revision={revision}
# Check status rollback => kubectl -n {namespace_name} rollout status deployments {deployment_name}

# Delete deployment => kubectl -n {namespace_name} delete deployments.apps {deployment_name}
# Note: Khi đó hệ thống sẽ xóa deployment và các ReplicaSet/Pod của deployment đó đi.
